Bug 590355 - Review Request: golly - cellular automata simulator
Review Request: golly - cellular automata simulator
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Terje Røsten
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2010-05-08 23:19 EDT by Eric Smith
Modified: 2012-03-28 16:39 EDT (History)
6 users (show)

See Also:
Fixed In Version: golly-2.3-3.el6
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2011-04-15 17:45:19 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
terjeros: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)
Mock build log in F-13 (18.60 KB, text/plain)
2010-05-26 10:11 EDT, Sergio Pascual
no flags Details

  None (edit)
Description Eric Smith 2010-05-08 23:19:12 EDT
Spec URL: http://fedorapeople.org/~brouhaha/golly/golly.spec
SRPM URL: http://fedorapeople.org/~brouhaha/golly/golly-2.1-1.fc12.src.rpm
Description:
Golly is an open source application for exploring Conway's Game of
Life and other cellular automata.  Golly supports unbounded universes
with up to 256 states.  Golly supports multiple algorithms, including
Bill Gosper's super fast hashlife algorithm.  Many different types of
CA are included: John von Neumann's 29-state CA, Wolfram's 1D rules,
WireWorld, Generations, Langton's Loops, Paterson's Worms, etc.
Comment 1 Eric Smith 2010-05-09 12:58:56 EDT
Improved patch to pass in data dir from spec via makefile rather than hard coding.

Spec URL: http://fedorapeople.org/~brouhaha/golly/golly.spec
SRPM URL: http://fedorapeople.org/~brouhaha/golly/golly-2.1-2.fc12.src.rpm
Comment 2 Terje Røsten 2010-05-11 03:58:44 EDT
Some initial comments:

o In the optflags patch can you remove the -O5 too, %{optflags} already adds -O2.

o Please use only on of the forms $RPM_BUILD_ROOT and %{buildroot}.

o The package seems to create dirs that are unowned e.g. /usr/share/golly
  and /usr/share/golly/Rules, please have a look.

o I wonder the meaning of this in %build:
   echo "flags = \'%{optflags}\'"

o Check if the standard sf.net source url can be used:
  https://fedoraproject.org/wiki/Packaging:SourceURL#Sourceforge.net
Comment 3 Susi Lehtola 2010-05-11 04:22:56 EDT
As per Terje's comment, I'd suggest using plain and simple
 %{_datadir}/%{name}/
 %exclude %{_datadir}/%{name}/Rules/TableGenerators/
 %exclude %{_datadir}/%{name}/Rules/TreeGenerators/
in %files of the main package, that way everything is owned as it should. What you won't get this way is the Help directory marked as %doc, but I don't think it should be marked as such anyway, since it may well be needed for runtime.
Comment 4 Terje Røsten 2010-05-11 04:36:21 EDT
+1


Talking about docs, seems like golly is searching in working directory to find help files, not %{_datadir}/%{name}/Help/. Please have a look.
Comment 5 Eric Smith 2010-05-12 02:27:02 EDT
The standard Sourceforge path doesn't work, which is why I didn't use it.  I've added a comment to the spec.

Good catch on the help files.  I'd tested that with an earlier version of my appdir patch, but broke it in a more recent patch.  Note that if you've run the broken version you may have to delete your preferences directory ~/.golly before the fixed version will work properly.

Other changes made per recommendations.  Thanks!

Spec URL: http://fedorapeople.org/~brouhaha/golly/golly.spec
SRPM URL: http://fedorapeople.org/~brouhaha/golly/golly-2.1-3.fc12.src.rpm
Comment 6 Terje Røsten 2010-05-12 14:09:31 EDT
During testing I found a problem with python scripts, golly wanted
to load libpython2.5.so, while Fedora ships libpython2.6.so.

Then, there is an known bug in wxpython.cpp on 64 bits hosts:

 http://golly.cvs.sourceforge.net/viewvc/golly/golly/src/wxpython.cpp?r1=1.70&r2=1.71

Updated package fixing those available here:

spec: http://terjeros.fedorapeople.org/golly/golly.spec
srpm: http://terjeros.fedorapeople.org/golly/golly-2.1-3.fc11.src.rpm


A new issue popped up:

golly.x86_64: E: non-executable-script /usr/share/golly/Help/Lexicon/modify.pl 0644 /usr/bin/perl

Seems like modify.pl is using during build and can be removed from the package?

Fix thos issue and include the python fixes and the package is more or less ready.
Comment 7 Eric Smith 2010-05-12 18:24:31 EDT
Thanks for all your help with this!  Updated with your patches and other suggestions:

Spec URL: http://fedorapeople.org/~brouhaha/golly/golly.spec
SRPM URL: http://fedorapeople.org/~brouhaha/golly/golly-2.1-4.fc12.src.rpm
Comment 8 Sergio Pascual 2010-05-26 10:10:49 EDT
It doesn't build in F-13 x86_64

/builddir/build/BUILD/golly-2.1-src/wxperl.cpp:2560: undefined reference to `Per
l_newSV_type'
ObjGTK/wxperl.o: In function `pl_getclip':
/builddir/build/BUILD/golly-2.1-src/wxperl.cpp:1566: undefined reference to `Perl_newSV_type'
ObjGTK/wxperl.o: In function `pl_join':
/builddir/build/BUILD/golly-2.1-src/wxperl.cpp:1454: undefined reference to `Perl_newSV_type'
ObjGTK/wxperl.o: In function `pl_getcells':
/builddir/build/BUILD/golly-2.1-src/wxperl.cpp:1380: undefined reference to `Perl_newSV_type'
/builddir/build/BUILD/golly-2.1-src/wxperl.cpp:1380: undefined reference to `Perl_newSV_type'
ObjGTK/wxperl.o:/builddir/build/BUILD/golly-2.1-src/wxperl.cpp:1186: more undefined references to `Perl_newSV_type' follow
collect2: ld returned 1 exit status
make: *** [golly] Error 1
Comment 9 Sergio Pascual 2010-05-26 10:11:48 EDT
Created attachment 416851 [details]
Mock build log in F-13
Comment 10 Eric Smith 2010-05-31 19:50:36 EDT
Other people have seen this problem when using Perl 5.10.1 (as in F13) vs. Perl 5.10.0 (as in F12):

http://www.gossamer-threads.com/lists/perl/porters/246793

However, it's not yet clear to me how to fix it.  I'll keep poking at it and/or ask for advice from people that might have a clue about Perl embedding.  

Reported upstream in the SourceForge tracker:

https://sourceforge.net/tracker/?func=detail&aid=3009700&group_id=139354&atid=743285
Comment 11 Eric Smith 2010-05-31 21:34:37 EDT
Fixed F-13 build by adding patch suggested in comment on SourceForge bug:

Spec URL: http://fedorapeople.org/~brouhaha/golly/golly.spec
SRPM URL: http://fedorapeople.org/~brouhaha/golly/golly-2.1-5.fc12.src.rpm    
Koji scratch build for F-13:
http://koji.fedoraproject.org/koji/taskinfo?taskID=2221047
Comment 12 Terje Røsten 2010-06-02 14:43:37 EDT
perl scripts have similar problems as python scripts, however a bit worse, is not enough with a rename as libperl.so is not located in a standard lib dir, I got some ideas from ocaml-perl4caml and wrote a patch to fix that issue, please have a look:

spec: http://terjeros.fedorapeople.org/golly/golly.spec
srpm: http://terjeros.fedorapeople.org/golly/golly-2.1-6.fc13.src.rpm
Comment 13 Eric Smith 2010-06-02 15:00:29 EDT
Added a trivial spec change from your -6 spec to eliminate an rpmlint warning about mixed spaces/tabs in spec.

Spec URL: http://fedorapeople.org/~brouhaha/golly/golly.spec
SRPM URL: http://fedorapeople.org/~brouhaha/golly/golly-2.1-7.fc12.src.rpm
Comment 14 Jason Tibbitts 2010-11-19 11:29:06 EST
Just a note that the embedded copy of the life lexicon is definitely not GPLv2+:  

"
This lexicon is copyright © Stephen Silver, 1997-2005. It may be freely copied and/or modified as long as due credit is given. This includes not just credit to those who have contributed in some way to the present version (see above), but also credit to those who have made any modifications.
"

This looks to be new (for Fedora, at least) license, which the legal folks will need to look at.
Comment 15 Eric Smith 2010-12-14 01:17:53 EST
I've posted on the legal list asking about the license for the lexicon, and will update the spec again once that is resolved.  In the mean time I have updated to latest upstream, 2.2, which eliminates the need for all but one of the patches.  

Spec URL: http://fedorapeople.org/~brouhaha/golly/golly.spec
SRPM URL: http://fedorapeople.org/~brouhaha/golly/golly-2.2-1.fc12.src.rpm
Koji scratch build for F-14:
http://koji.fedoraproject.org/koji/taskinfo?taskID=2662658
Comment 16 Tom "spot" Callaway 2010-12-14 14:13:19 EST
lexicon license is missing permission to distribute, I've emailed upstream asking for clarification.
Comment 17 Eric Smith 2011-04-05 21:44:18 EDT
Stephen Silver has released the Life Lexicon under a Creative Commons Attribution ShareAlike 3.0 Unported license (CC-BY-SA).  The actual release ZIP file has not been changed, but the notice is on the official web page: http://www.argentum.freeserve.co.uk/lex_home.htm

I have updated the RPM package to include that web page a Source, and include it as a doc.  It is expected that future releases of the Life Lexicon and/or Golly will include the notice.

I think this should resolve the license problem, but if not, let me know.

Spec URL: http://fedorapeople.org/~brouhaha/golly/golly.spec
SRPM URL: http://fedorapeople.org/~brouhaha/golly/golly-2.2-2.fc14.src.rpm
Koji scratch build for rawhide:
http://koji.fedoraproject.org/koji/taskinfo?taskID=2977407
Comment 18 Tom "spot" Callaway 2011-04-06 10:20:38 EDT
Fantastic! Stephen never replied to my email, but this is a solid result. Lifting FE-Legal.
Comment 19 Terje Røsten 2011-04-07 13:33:49 EDT
ok rpmlint - some warning safe to ignore.
ok naming (name, spec and version)
ok legal
ok LICENSE in %doc *)
ok source tarball:    
sha256sum golly-2.2-src.tar.gz*
cf7fbfd3df3c4cefcd7c4cc881011b2128f7255aacb6c79e93b7f10d3640abc2  golly-2.2-src.tar.gz
cf7fbfd3df3c4cefcd7c4cc881011b2128f7255aacb6c79e93b7f10d3640abc2  golly-2.2-src.tar.gz.1
ok builds fine in koji
ok dirs, perms, ownes and utf-8
ok macro usage
ok .desktop file (with desktop-file-validate)
ok optflags used during build

*) LICENSE says GPLv2, but license headers in code is GPLv2+.

With legal stuff ok, I don't find any serious issues here.

 The package golly is APPOVED.
Comment 20 Eric Smith 2011-04-07 14:26:52 EDT
New Package SCM Request
=======================
Package Name: golly
Short Description: Cellular automata simulator (includes Conway's Game of Life)
Owners: brouhaha
Branches: f14 f15
InitialCC:
Comment 21 Jason Tibbitts 2011-04-07 14:34:14 EDT
Git done (by process-git-requests).
Comment 22 Fedora Update System 2011-04-08 02:57:13 EDT
golly-2.2-2.fc15 has been submitted as an update for Fedora 15.
https://admin.fedoraproject.org/updates/golly-2.2-2.fc15
Comment 23 Fedora Update System 2011-04-08 02:57:49 EDT
golly-2.2-2.fc14 has been submitted as an update for Fedora 14.
https://admin.fedoraproject.org/updates/golly-2.2-2.fc14
Comment 24 Fedora Update System 2011-04-08 19:17:38 EDT
golly-2.2-2.fc14 has been pushed to the Fedora 14 testing repository.
Comment 25 Fedora Update System 2011-04-15 17:45:12 EDT
golly-2.2-2.fc15 has been pushed to the Fedora 15 stable repository.
Comment 26 Fedora Update System 2011-04-18 17:21:11 EDT
golly-2.2-2.fc14 has been pushed to the Fedora 14 stable repository.
Comment 27 Eric Smith 2012-03-11 03:23:07 EDT
Package Change Request
======================
Package Name: golly
New Branches: el6
Owners: brouhaha
Comment 28 Gwyn Ciesla 2012-03-12 08:03:26 EDT
Git done (by process-git-requests).
Comment 29 Fedora Update System 2012-03-12 15:12:56 EDT
golly-2.3-3.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/golly-2.3-3.el6
Comment 30 Fedora Update System 2012-03-28 16:39:37 EDT
golly-2.3-3.el6 has been pushed to the Fedora EPEL 6 stable repository.

Note You need to log in before you can comment on or make changes to this bug.